<script setup lang="ts">
import { useFoodStore } from '@/stores/food';
import { useQueueStore } from '@/stores/queue';
import type Orderitem from '@/types/Orderitem';
import type QueueAdd from '@/types/QueueAdd';
import type Queue from '@/types/Queue';
import { onMounted } from 'vue';

const foodStore = useFoodStore();
const queueStore = useQueueStore();
const userString = localStorage.getItem("user");
const user = userString ? JSON.parse(userString) : null;
onMounted(async () => {
  queueStore.cooks = await queueStore.getOrderToQueue("กำลังปรุงอาหาร");
  console.log(queueStore.cooks)
});

async function Confirm(item: Queue) {
  foodStore.queueAdd.id = item.id
  foodStore.queueAdd.orderitem = item.orderitem.id!;
  foodStore.queueAdd.status = "กำลังรอเสิร์ฟ"
  foodStore.queueAdd.emp_cook = user.id;
  await foodStore.saveQueue();
  foodStore.clear();
  getCook()
}

async function getCook() {
  queueStore.cooks = await queueStore.getOrderToQueue("กำลังปรุงอาหาร");
}

setInterval(getCook, 1000);
</script>
<template>
  <v-container fluid fill-height class="d-flex justify-center align-center">
    <v-row class="justify-center">
      <v-col>
        <v-card class="ma-5" color="#EEF2E6">
          <v-row class="justify-center">
            <v-card class="pa-5 ma-2 text-h4 text-center" width="100%" color="#1C6758"
              style="color: white"><label>รายการอาหาร</label></v-card>
          </v-row>
          <v-table id="cook" style="padding-top: 10px;">
            <thead>
              <tr>
                <th>รายการอาหาร</th>
                <th>หมายเหตุ</th>
                <th width="15%"></th>
              </tr>
            </thead>
            <tbody>
              <template v-for="item in queueStore.cooks">
                <tr :key="item.id" v-if="item.emp_cook.id === user.id ">
                  <td>{{ item.orderitem.menu.name }}</td>
                  <td>{{ item.orderitem.note }}</td>
                  <td class="text-center">
                    <v-btn size="x-large" class="btng" @click="Confirm(item)">Complete</v-btn>
                  </td>
                </tr>
              </template>
            </tbody>
          </v-table>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>
<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Noto+Sans+Thai:wght@100&display=swap");

label {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
  font-size: 48px !important;
}

th {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 24px !important;
  font-weight: bold !important;
}

td {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 22px !important;
  font-weight: bold;
}

#cook {
  border-collapse: collapse;
  width: 100%;
}

#cook td,
#cook th {
  padding: 10px;
  padding-left: 20px;
}

#cook th {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #1c6758;
  color: white;
}

#cook tr {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #ffefcf;
  color: black;
}

.btng {
  font-weight: bold;
  color: white;
  background-color: #00af91;
  width: 110px;
  font-size: 18px;
}

.btnr {
  font-weight: bold;
  color: white;
  background-color: #990000;
  width: 110px;
  font-size: 18px;
}</style>